// Iptscrae Keywords Header (used as source for KeywordParserMaker
// output list of function templates, list of enums, and switch statement


typedef struct {
	char	*keyWord;
	char *funcName;
} KeyWords;

/**

KeyWords keyWords[] = {
	"PUT",				"SF_PUT",
	"POP",				"SF_POP",
	"POSX",				"SF_POSX",
	"POSY",				"SF_POSY",
	"PRIVATEMSG",		"SF_PRIVATEMSG",
	NULL, NULL,
};

**/

KeyWords keyWords[] = {

#ifdef	DIRECTPLAY						// KAS Direct Play support
	"DP_DPLAYVERSION",	"SF_DPLAYVERSION",
	"DP_NBRGAMES",		"SF_NBRGAMES",
	"DP_GETGAMENAME",	"SF_GETGAMENAME",
	"DP_GETGAMEGUID",	"SF_GETGAMEGUID",
	"DP_ISHOST",		"SF_ISHOST",
	"DP_ISPLAYER",		"SF_ISPLAYER",
	"DP_CANHOST",		"SF_CANHOST",
	"DP_CANJOIN",		"SF_CANJOIN",
	"DP_CANSTART",		"SF_CANSTART",
	"DP_NBRPLAYERS",	"SF_NBRPLAYERS",
	"DP_GETSPOTDPSTATE","SF_GETSPOTDPSTATE",
	"DP_SETSPOTGAMENAME","SF_SETSPOTGAMENAME",
	"DP_SETSPOTGAMEGUID","SF_SETSPOTGAMEGUID",
	"DP_GETSPOTGAMENAME","SF_GETSPOTGAMENAME",
	"DP_GETSPOTGAMEGUID","SF_GETSPOTGAMEGUID",
#endif	// Direct Play

	"GLOBAL",			"SF_GLOBAL",
	"DEF",				"SF_DEF",
	"EXEC",				"SF_EXEC",
	"IF",				"SF_IF",
	"IFELSE",			"SF_IFELSE",
	"WHILE",			"SF_WHILE",
	"ALARMEXEC",		"SF_ALARMEXEC",
	"NOT",				"SF_NOT",
	"AND",				"SF_AND",
	"OR",				"SF_OR",
	"GOTOROOM",			"SF_GOTOROOM",
	"SAY",				"SF_SAY",
	"CHAT",				"SF_SAY",
	"DEST",				"SF_DEST",
	"ME",				"SF_ME",
	"ID",				"SF_ME",
	"ITOA",				"SF_ITOA",
	"GET",				"SF_GET",
	"PUT",				"SF_PUT",
	"ARRAY",			"SF_ARRAY",
	"LOCK",				"SF_LOCK",
	"SETPICLOC",		"SF_SETPICLOC",
	"SETLOC",			"SF_SETLOC",
	"SETSPOTSTATE",		"SF_SETSPOTSTATE",
	"SETSPOTSTATELOCAL","SF_SETSPOTSTATELOCAL",
	"SETALARM",			"SF_SETALARM",
	"GETSPOTSTATE",		"SF_GETSPOTSTATE",
	"ADDLOOSEPROP",		"SF_ADDLOOSEPROP",
	"DOFFPROP",			"SF_DOFFPROP",
	"DONPROP",			"SF_DONPROP",
	"REMOVEPROP",		"SF_REMOVEPROP",
	"CLEARPROPS",		"SF_CLEARPROPS",
	"NAKED",			"SF_CLEARPROPS",
	"CLEARLOOSEPROPS",	"SF_CLEARLOOSEPROPS",
	"SETCOLOR",			"SF_SETCOLOR",
	"SETFACE",			"SF_SETFACE",
	"UNLOCK",			"SF_UNLOCK",
	"ISLOCKED",			"SF_ISLOCKED",
	"GLOBALMSG",		"SF_GLOBALMSG",
	"ROOMMSG",			"SF_ROOMMSG",
	"SUSRMSG",			"SF_SUSRMSG",
	"LOCALMSG",			"SF_LOCALMSG",
	"DELAY",			"SF_DELAY",
	"RANDOM",			"SF_RANDOM",
	"RND",				"SF_RANDOM",
	"SUBSTR",			"SF_SUBSTR",
	"GREPSTR",			"SF_GREPSTR",
	"GREPSUB",			"SF_GREPSUB",
	"LAUNCHAPP",		"SF_LAUNCHAPP",
	"SHELLCMD",			"SF_SHELLCMD",
	"KILLUSER",			"SF_KILLUSER",
	"NETGOTO",			"SF_NETGOTO",
	"GOTOURL",			"SF_NETGOTO",
	"MACRO",			"SF_MACRO",
	"MOVE",				"SF_MOVE",
	"SETPOS",			"SF_SETPOS",
	"INSPOT",			"SF_INSPOT",
	"LOGMSG",			"SF_LOGMSG",
	"SHOWLOOSEPROPS",	"SF_SHOWLOOSEPROPS",
	"SERVERNAME",		"SF_SERVERNAME",
	"USERNAME",			"SF_USERNAME",
	"SELECT",			"SF_SELECT",		// 7/28/95
	"NBRSPOTS",			"SF_NBRSPOTS",		// 7/28/95
	"NBRDOORS",			"SF_NBRDOORS",		// 7/28/95
	"DOORIDX",			"SF_DOORIDX",		// 7/28/95
	"SPOTIDX",			"SF_SPOTIDX",		// 7/28/95
	"EXIT",				"SF_EXIT",
	"RETURN",			"SF_RETURN",
	"BREAK",			"SF_BREAK",
	"FOREACH",			"SF_FOREACH",

	"DUP",				"SF_DUP",
	"SWAP",				"SF_SWAP",
	"POP",				"SF_POP",
	"BEEP",				"SF_BEEP",
	"LENGTH",			"SF_LENGTH",
	"WHOCHAT",			"SF_WHOCHAT",
	"WHOME",			"SF_WHOME",
	"POSX",				"SF_POSX",
	"POSY",				"SF_POSY",
	"PRIVATEMSG",		"SF_PRIVATEMSG",
	"STATUSMSG",		"SF_STATUSMSG",
	"SPOTDEST",			"SF_SPOTDEST",
	"UPPERCASE",		"SF_UPPERCASE",
	"LOWERCASE",		"SF_LOWERCASE",
	"DROPPROP",			"SF_DROPPROP",
	"TOPPROP",			"SF_TOPPROP",
	"ISGUEST",			"SF_ISGUEST",
	"DIMROOM",			"SF_DIMROOM",
	"DATETIME",			"SF_DATETIME",
    "TICKS",			"SF_TICKS",

	"SPOTNAME",			"SF_SPOTNAME",
	"SOUND",			"SF_SOUND",
	"MIDIPLAY",			"SF_MIDIPLAY",
	"MIDILOOP",			"SF_MIDILOOP",
	"MIDISTOP",			"SF_MIDISTOP",
	"PENFRONT",			"SF_PENFRONT",	// 10/19
	"PENBACK",			"SF_PENBACK",
	"PENCOLOR",			"SF_PENCOLOR",
	"PENSIZE",			"SF_PENSIZE",
	"PENPOS",			"SF_PENPOS",
	"PENTO",			"SF_PENTO",
	"LINETO",			"SF_LINETO",
	"LINE",				"SF_LINE",

	"PAINTCLEAR",		"SF_PAINTCLEAR", // 10/23
	"PAINTUNDO",		"SF_PAINTUNDO",
	"HASPROP",			"SF_HASPROP",
	"NBRUSERPROPS",		"SF_NBRUSERPROPS",
	"USERPROP",			"SF_USERPROP",
	"USERID",			"SF_USERID",
	"WHOPOS",			"SF_WHOPOS",
	"NBRROOMUSERS",		"SF_NBRROOMUSERS",
	"ROOMUSER",			"SF_ROOMUSER",
	"SAYAT",			"SF_SAYAT",
	"MOUSEPOS",			"SF_MOUSEPOS",
	"WHONAME",			"SF_WHONAME",
	"WHOTARGET",		"SF_WHOTARGET",
	"ROOMNAME",			"SF_ROOMNAME",
	"STRTOATOM",		"SF_STRTOATOM",
	"ATOI",				"SF_ATOI",
	"ROOMID",			"SF_ROOMID",
	"SETPROPS",			"SF_SETPROPS",
	"ISWIZARD",			"SF_ISWIZARD",
	"ISGOD",			"SF_ISGOD",
	"LAUNCHPPA",		"SF_LAUNCHPPA",	// 6/27/96
	"TALKPPA",			"SF_TALKPPA",	// 6/27/96


	NULL,				NULL};

